
#ifndef CAMERA_H
#define CAMERA_H

// Requires Geometry.h

#ifndef PI
	#define PI 3.14159265358979323846
#endif

class TCamera
{
public:
	TCamera();

	void setMatrices();
	void moveForward( float d );
	void turn( float d ); 
	void pitch( float d );
	void climb( float d );
	void panvertical( float d );
	void panhorizontal( float d );
	void setPosition(float x,float y,float z);
	void setHeading(float v);
	void setPitch(float v);

protected:
	TVector3		m_Position;
	float			m_Heading, m_Pitch;		
	TVector3		m_Direction; 

	void calculateDirection();
};



#endif

